﻿Imports System.Data.SqlClient
Imports System.Data.Sql

Public Class Form1
    Dim connStr As String
    Dim rowIndx As Integer
    Dim currMang As CurrencyManager
    Dim driveDT As New DataTable
    Dim connDonor As SqlConnection
    Dim dataAdapterDrive As SqlDataAdapter
    Dim commandbuilderDrive As SqlCommandBuilder
    Dim currpath As String = System.Environment.CurrentDirectory
    Dim savDriveNo As String
    Dim savDriveName As String
    Dim savDriveChair As String
    Dim savYTDTotal As String
    Dim savLastYrTotal As String
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Dim result As Integer = MessageBox.Show("Commit changes to database?", "WARNING!", MessageBoxButtons.YesNo)
        If result = DialogResult.Yes Then
            Try
                dataAdapterDrive.Update(driveDT)
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        End If
        connDonor.Close()
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' connStr = "Provider=Microsoft.ACE.OLEDB.12.0; " & _
        '           "Data Source=" & currpath & "\donor.accdb"
        connStr = "Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename=|DataDirectory|\DonorDB.mdf;Integrated Security=True;Connect Timeout=30"
        ' Dim connDonor As New sqlConnection(connStr)
        connDonor = New SqlConnection(connStr)
        Dim sqlStrDrive As String = "Select * from Drive"
        dataAdapterDrive = New SqlDataAdapter(sqlStrDrive, connDonor)
        commandbuilderDrive = New SqlCommandBuilder(dataAdapterDrive)
        dataAdapterDrive.FillSchema(driveDT, SchemaType.Mapped)
        dataAdapterDrive.Fill(driveDT)
        rowIndx = 0
        Dim drCurrRow As DataRow = driveDT.Rows.Item(rowIndx)
        FillTextBoxes(drCurrRow)
        currMang = CType(BindingContext(driveDT), CurrencyManager)
    End Sub
    Private Sub btnAdd_Click(sender As Object, e As EventArgs) Handles btnAdd.Click
        Dim newRecord As DataRow
        Try
            newRecord = driveDT.NewRow()
            newRecord("driveno") = txtDriveNo.Text
            newRecord("drivename") = txtDriveName.Text
            newRecord("drivechair") = txtDriveChair.Text
            newRecord("thisyear") = txtYTDTotal.Text
            newRecord("lastyear") = txtLastYrTotal.Text
            Try
                driveDT.Rows.Add(newRecord)
            Catch ex As Exception
                MsgBox("Drive " & newRecord("driveno") & " already exists. Add cancelled.")
            End Try
        Catch ex As Exception
            MsgBox("Invalid data. Add cancelled")
        End Try


    End Sub
    Sub FillTextBoxes(currRow As DataRow)
        txtDriveNo.Text = CStr(currRow.Item("driveno"))
        txtDriveName.Text = CStr(currRow.Item("drivename"))
        txtDriveChair.Text = CStr(currRow.Item("drivechair"))
        txtYTDTotal.Text = CStr(currRow.Item("thisyear"))
        txtLastYrTotal.Text = CStr(currRow.Item("lastyear"))
    End Sub
    Private Sub btnShow_Click(sender As Object, e As EventArgs) Handles btnShow.Click
        grdShow.DataSource = driveDT
    End Sub

    Private Sub btnChange_Click(sender As Object, e As EventArgs) Handles btnChange.Click
        Try
            dataAdapterDrive.Update(driveDT)
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub btnNext_Click(sender As Object, e As EventArgs) Handles btnNext.Click

        If rowIndx < driveDT.Rows.Count - 1 Then
            rowIndx = rowIndx + 1
            currMang.Position = currMang.Position + 1
        Else
            rowIndx = 0
            currMang.Position = 0
        End If
        Dim drCurrRow As DataRow = driveDT.Rows.Item(rowIndx)
        FillTextBoxes(drCurrRow)
    End Sub

    Private Sub btnClear_Click(sender As Object, e As EventArgs) Handles btnClear.Click
        ClearFields()
    End Sub

    Private Sub ClearFields()
        txtDriveNo.Clear()
        txtDriveName.Clear()
        txtDriveChair.Clear()
        txtYTDTotal.Clear()
        txtLastYrTotal.Clear()
    End Sub


    Private Sub btnFind_Click(sender As Object, e As EventArgs) Handles btnFind.Click
        Dim srchKey As String = txtDriveNo.Text
        Try
            Dim Drive As DataRow = driveDT.Rows.Find(srchKey)
            rowIndx = driveDT.Rows.IndexOf(Drive)
            currMang.Position = rowIndx
            FillTextBoxes(Drive)

        Catch ex As Exception
            'MsgBox(ex.ToString)
            MsgBox("Drive " & srchKey & " does not exist")
        End Try
    End Sub

    Private Sub btnRemove_Click(sender As Object, e As EventArgs) Handles btnRemove.Click
        Dim srchKey As String = txtDriveNo.Text
        Try
            Dim Drive As DataRow = driveDT.Rows.Find(srchKey)
            rowIndx = driveDT.Rows.IndexOf(Drive)
            currMang.Position = rowIndx
            FillTextBoxes(Drive)
            Dim result As Integer = MessageBox.Show("Delete this record?", "WARNING!", MessageBoxButtons.YesNo)
            If result = DialogResult.Yes Then
                Try
                    driveDT.Rows.Find(srchKey).Delete()
                    ClearFields()
                Catch ex As Exception
                    MsgBox(ex.ToString)
                End Try
            End If
        Catch ex As Exception
            MsgBox("Drive " & srchKey & " does not eist")
        End Try
    End Sub

    Private Sub btnUpdate_Click(sender As Object, e As EventArgs) Handles btnUpdate.Click
        Dim srchKey As String = txtDriveNo.Text
        Try
            Dim Drive As DataRow = driveDT.Rows.Find(srchKey)
            rowIndx = driveDT.Rows.IndexOf(Drive)
            currMang.Position = rowIndx
            Dim result As Integer = MessageBox.Show("Make changes to this record?", "WARNING!", MessageBoxButtons.YesNo)
            If result = DialogResult.Yes Then
                SaveData(Drive)
                driveDT.Rows.Item(rowIndx).BeginEdit()
                driveDT.Rows.Item(rowIndx)("driveno") = txtDriveNo.Text
                driveDT.Rows.Item(rowIndx)("drivename") = txtDriveName.Text
                driveDT.Rows.Item(rowIndx)("drivechair") = txtDriveChair.Text
                driveDT.Rows.Item(rowIndx)("thisyear") = txtYTDTotal.Text
                driveDT.Rows.Item(rowIndx)("lastyear") = txtLastYrTotal.Text
                driveDT.Rows.Item(rowIndx).EndEdit()
            End If
        Catch ex As Exception
            RestoreData(rowIndx)
            MsgBox("Invalid data. Update cancelled")
        End Try
    End Sub

    Sub SaveData(currRow As DataRow)
        savDriveNo = CStr(currRow.Item("driveno"))
        savDriveName = CStr(currRow.Item("drivename"))
        savDriveChair = CStr(currRow.Item("drivechair"))
        savYTDTotal = CStr(currRow.Item("thisyear"))
        savLastYrTotal = CStr(currRow.Item("lastyear"))
    End Sub

    Sub RestoreData(rowIndx)
        driveDT.Rows.Item(rowIndx).BeginEdit()
        driveDT.Rows.Item(rowIndx)("driveno") = savDriveNo
        driveDT.Rows.Item(rowIndx)("drivename") = savDriveName
        driveDT.Rows.Item(rowIndx)("drivechair") = savDriveChair
        driveDT.Rows.Item(rowIndx)("thisyear") = savYTDTotal
        driveDT.Rows.Item(rowIndx)("lastyear") = savLastYrTotal
        driveDT.Rows.Item(rowIndx).EndEdit()
    End Sub

End Class
